unit ChaosUnt;

interface


// 10 -1.0669 1.123406 1 -1.0005
// 0.00 0.00001 500

// 10 1.0669 1.123406 1 -1.0005
// -843815784.669 0.001 5000

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, StdCtrls, Math, Spin;

type
  TChaosForm = class(TForm)
    PanelTop: TPanel;
    Status: TStatusBar;
    PanelClient: TPanel;
    RenderBtn: TButton;
    InitValEdt: TEdit;
    Label1: TLabel;
    PaintBox: TPaintBox;
    IncEdt: TEdit;
    Label2: TLabel;
    SpeedEdt: TSpinEdit;
    Label3: TLabel;
    Label5: TLabel;
    ExpEdt: TEdit;
    PanelLeft: TPanel;
    ViewGroup: TRadioGroup;
    ClearBtn: TButton;
    Aedt: TEdit;
    BEdt: TEdit;
    CEdt: TEdit;
    DEdt: TEdit;
    NoiseEdt: TEdit;
    Modulate: TCheckBox;
    InBtn1: TButton;
    InBtn2: TButton;
    inbtn3: TButton;
    inbtn4: TButton;
    inbtn5: TButton;
    procedure RenderBtnClick(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure InitValEdtChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure InBtn1Click(Sender: TObject);
    procedure InBtn2Click(Sender: TObject);
    procedure inbtn3Click(Sender: TObject);
    procedure inbtn4Click(Sender: TObject);
    procedure inbtn5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Formula : String;
    InitialValue   : Extended;
    YVal           : Extended;
    XVal           : Extended;
    WVal           : Extended;
    ZVal           : Extended;
    CurX           : longint;
    Input          : Dword;
    procedure Clear;
    Function  RenderChaos(CurrentX : Dword) : Dword;
    Procedure ShiftBox(ToX : Dword);
    Procedure ChaosDraw2D;
    Procedure ChaosDraw3D;
    Procedure ChaosDraw4D;
    procedure DrawSpectrum(Var A : Dword);
    procedure DoFFT(VAR data:array of double; pSize : Dword);
  end;

var
  ChaosForm: TChaosForm;

implementation

{$R *.DFM}

Function DrawThread(ThreadData : Pointer) : Dword;
var CurrentX : Dword;
Begin
     Result         := 0;
     ChaosForm.YVal := ChaosForm.InitialValue;
     CurrentX       := 0;
     ChaosForm.CurX := 0;
     Repeat
            CurrentX := ChaosForm.RenderChaos(CurrentX);
            Sleep(ChaosForm.SpeedEdt.Value);
     until (ChaosForm.RenderBtn.Tag = 0);

     EndThread(0);
end;

Procedure TChaosForm.ShiftBox(ToX : Dword);
Var Dst, Src : TRect;
Begin
     Dst.Left   := 0;
     Dst.Right  := Tox;
     Dst.Top    := 0;
     Dst.Bottom := PaintBox.Height;

     Src.Left   := PaintBox.Width-LongInt(ToX);
     Src.Right  := PaintBox.Width;
     Src.Bottom := PaintBox.Height;
     Src.Top    := 0;

     PaintBox.Canvas.Lock;
     PaintBox.Canvas.CopyRect(Dst,PaintBox.Canvas,Src);
     PaintBox.Canvas.Unlock;

     Src.Left   := ToX;
     Src.Right  := PaintBox.Width;
     Src.Bottom := PaintBox.Height;
     Src.Top    := 0;


     PaintBox.Canvas.Lock;
     PaintBox.Canvas.Brush.color := $000000;
     PaintBox.Canvas.FillRect(src);
     PaintBox.Canvas.Unlock;

end;

Function TChaosForm.RenderChaos(CurrentX : Dword) : Dword;
Var DrawX      : Longint;
    DrawY      : LongInt;
Begin
    // ShowMessage('DEBUG <func> : '+Func);
     If (CurrentX = 0) then
        Begin
            DrawX := 0;
        end
           else
        Begin
             DrawX := LongInt(CurrentX)-(PaintBox.Width div 6);
             ShiftBox(DrawX);
        end;

     Repeat
           YVal := YVal + StrToFloat(NoiseEdt.Text);
           NoiseEdt.Text := FloatToStr(StrToFloat(NoiseEdt.Text)+0.01);
           Try
              YVal := (sin(StrToFloat(CEdt.Text)* XVal) - cos(StrToFloat(DEdt.Text)* YVal))*(CurX*StrToFloat(IncEdt.Text));

             //YVal := (power(YVal, StrToFloat(ExpEdt.Text)))+StrToFloat(ConstEdt.Text)+(CurX*StrToFloat(IncEdt.Text));
             //YVal := Yval-Trunc(YVal);
           except
           end;

           DrawY := trunc(abs(YVal*PaintBox.Height));
           PaintBox.Canvas.Lock;
           PaintBox.Canvas.Pen.Color := $FFFFFF;
           PaintBox.canvas.MoveTo(DrawX,DrawY);
           PaintBox.canvas.LineTo(DrawX+2,DrawY);
           PaintBox.Canvas.UnLock;
           inc(DrawX);
           inc(CurX);
     until (DrawX > PanelClient.Width);

     Result := DrawX;
end;

procedure TChaosForm.ChaosDraw2D;
var DrawX, DrawY : Dword;
    Iterator     : Dword;
    xtmp : double;
    ytmp : double;
    A    : Dword;
begin
     Xtmp := InitialValue;
     Ytmp := InitialValue;
     Status.SimpleText := 'Rendering 2D Image . . .';
     Iterator := 0;
     XVal := InitialValue;
     YVal := InitialValue;
     randomize;
     Repeat
           If (XVal > 0.1) then
           Begin
                XVal := XVal - 0.2;
           end
              else
           Begin
                XVal := XVal + 0.2;
           end;

           Try
            XVal := sin(StrToFloat(AEdt.Text)* YVal) - cos(StrToFloat(BEdt.Text)* XVal);
            YVal := sin(StrToFloat(CEdt.Text)* XVal) - cos(StrToFloat(DEdt.Text)* YVal);
            XVAL := Xval + (1/(INPUT+1));
            YVAL := Yval + (1/(INPUT+1));



            Xtmp := XVal  + (1-Xtmp);
            ytmp := YVal  + (1-ytmp);
          //   XVal := (power(YVal, StrToFloat(ExpEdt.Text)))+StrToFloat(ConstEdt.Text)+(Iterator*StrToFloat(IncEdt.Text));
          //   XVal := sin(XVal)- cos(YVal);
           //  XVal := Xval-Trunc(XVal);
          //   YVal := sin(YVal)- cos(XVal);
           //  YVal := Yval-Trunc(YVal);
           except
           end;

           If (Modulate.Checked) then
           Begin
               DrawX := trunc(abs(Xtmp*PaintBox.Width/2));
               DrawY := trunc(abs(Ytmp*PaintBox.Height/2));
           end
              else
           Begin
               DrawX := trunc(abs(XVal*PaintBox.Width/2));
               DrawY := trunc(abs(YVal*PaintBox.Height/2));
           end;

           PaintBox.Canvas.Lock;
           PaintBox.Canvas.Pen.Color := $FFFFFF;
           PaintBox.canvas.MoveTo(DrawX,DrawY);
           PaintBox.canvas.LineTo(DrawX+2,DrawY);
           PaintBox.Canvas.UnLock;

           inc(Iterator);
           Application.ProcessMessages;
      until (RenderBtn.Tag = 0);

      If (RenderBtn.Tag = 1) then
      Begin
         RenderBtn.Caption := '[- Render -]';
         RenderBtn.Tag     := 0;
      end;

      Status.SimpleText := '2D Image Rendered!';
end;

procedure TChaosForm.ChaosDraw3D;
var DrawX, DrawY : Dword;
    Iterator     : Extended;
    Counter      : Dword;
begin
     Status.SimpleText := 'Rendering 3D Image . . .';
     Iterator := 0;
     Counter  := 0;
     Repeat
           Try
            XVal := sin(StrToFloat(AEdt.Text)* YVal) - cos(StrToFloat(BEdt.Text)* XVal);
            YVal := sin(StrToFloat(CEdt.Text)* XVal) - cos(StrToFloat(DEdt.Text)* YVal);
            YVal := sin(YVal)*(cos(Iterator+Xval)+sin(Iterator+YVal));
            ZVal := cos(ZVal)*(cos(Iterator+Xval)+sin(Iterator+YVal));
           except
           end;
          try
           DrawX := Trunc(abs((XVal) / (ZVal) *PaintBox.Width/2 ));
           DrawY := Trunc(abs((YVal) / (ZVal) *PaintBox.Height/2 ));
           except
           end;

         //  DrawX := trunc(abs(XVal*PaintBox.Width));
          // DrawY := trunc(abs(YVal*PaintBox.Height));

           PaintBox.Canvas.Lock;
           PaintBox.Canvas.Pen.Color := $FFFFFF;
           PaintBox.canvas.MoveTo(DrawX,DrawY);
           PaintBox.canvas.LineTo(DrawX+2,DrawY);
           PaintBox.Canvas.UnLock;

           try
              Iterator := Iterator + (StrToFloat(IncEdt.Text));
           except
           end;
           inc(Counter);
           If (Counter > StrToIntDef(ExpEdt.Text,50)) then
           begin
                Counter := 0;
                Clear;
                Sleep(ChaosForm.SpeedEdt.Value);
           end;
           Application.ProcessMessages;
      until (RenderBtn.Tag = 0);

      If (RenderBtn.Tag = 1) then
      Begin
         RenderBtn.Caption := '[- Render -]';
         RenderBtn.Tag     := 0;
      end;

      Status.SimpleText := '3D Image Rendered!';
end;

procedure TChaosForm.ChaosDraw4D;
var DrawX, DrawY : Dword;
    Iterator     : Extended;
    Counter      : Dword;
begin
     Status.SimpleText := 'Rendering 4D Image . . .';
     Iterator := 0;
     Counter  := 0;
     Repeat
           Try
            XVal := sin(StrToFloat(AEdt.Text)* YVal) - cos(StrToFloat(BEdt.Text)* XVal);
            YVal := sin(StrToFloat(CEdt.Text)* XVal) - cos(StrToFloat(DEdt.Text)* YVal);
            YVal := sin(YVal)*(cos(Iterator+Xval)+sin(Iterator+YVal));
            WVal := cos(WVal+Yval+XVal+ZVal+Iterator);
            ZVal := cos(ZVal)*(cos(Iterator+Xval)+sin(Iterator+YVal));
           except
           end;
          try
           DrawX := Trunc(abs((XVal) / (ZVal) /(WVal)*PaintBox.Width/2 ));
           DrawY := Trunc(abs((YVal) / (ZVal) /(WVal)*PaintBox.Height/2 ));
           except
           end;

         //  DrawX := trunc(abs(XVal*PaintBox.Width));
          // DrawY := trunc(abs(YVal*PaintBox.Height));

           PaintBox.Canvas.Lock;
           PaintBox.Canvas.Pen.Color := $FFFFFF;
           PaintBox.canvas.MoveTo(DrawX,DrawY);
           PaintBox.canvas.LineTo(DrawX+2,DrawY);
           PaintBox.Canvas.UnLock;

           try
              Iterator := Iterator + (StrToFloat(IncEdt.Text));
           except
           end;
           inc(Counter);
           If (Counter > StrToIntDef(ExpEdt.Text,50)) then
           begin
                Counter := 0;
                Clear;
                Sleep(ChaosForm.SpeedEdt.Value);
           end;
           Application.ProcessMessages;
      until (RenderBtn.Tag = 0);

      If (RenderBtn.Tag = 1) then
      Begin
         RenderBtn.Caption := '[- Render -]';
         RenderBtn.Tag     := 0;
      end;

      Status.SimpleText := '4D Image Rendered!';
end;


procedure TChaosForm.DoFFT(VAR data:array of double; pSize : Dword);
var
   ii,jj,n,mmax,m,j,istep,i,isign,nn: integer;
   wtemp,wr,wpr,wpi,wi,theta: double;
   tempr,tempi: double;
begin
   nn := PSize shr 1;

   isign := 1;

   n := nn shl 1;
   j := 1;
   for ii := 1 to nn do
   begin
      i := 2*ii-1;
      if (j > i) then
      begin
         tempr := data[j];
         tempi := data[j+1];
         data[j] := data[i];
         data[j+1] := data[i+1];
         data[i] := tempr;
         data[i+1] := tempi
      end;
      m := n shr 1;
      while ((m >= 2) AND (j > m))  DO
      begin
         j := j-m;
         m := m shr 1;
      end;
      j := j+m
   end;
   mmax := 2;
   while (n > mmax) do
   begin
      istep := 2*mmax;
      theta := (2 * PI)/(isign*mmax);
      wpr := -2.0*sqr(sin(0.5*theta));
      wpi := sin(theta);
      wr := 1.0;
      wi := 0.0;
      for ii := 1 to (mmax shr 1) do
      begin
         m := 2*ii-1;
         for jj := 0 to ((n-m) DIV istep) do
         begin
            i := m + jj*istep;
            j := i+mmax;
            tempr := (wr)*data[j]-(wi)*data[j+1];
            tempi := (wr)*data[j+1]+(wi)*data[j];
            data[j] := data[i]-tempr;
            data[j+1] := data[i+1]-tempi;
            data[i] := data[i]+tempr;
            data[i+1] := data[i+1]+tempi
         end;
         wtemp := wr;
         wr := wr*wpr-wi*wpi+wr;
         wi := wi*wpr+wtemp*wpi+wi
      end;
      mmax := istep
   end;
end;

procedure TChaosForm.DrawSpectrum(Var A : Dword);
Var DrawX      : Longint;
    DrawY      : LongInt;
    B          : DWord;
    Sample     : Array[0..512] of Double;
    Spectra    : Array[0..512] of Double;
Begin
           Try
              YVal := (sin(StrToFloat(CEdt.Text)* XVal) - cos(StrToFloat(DEdt.Text)* YVal))*(CurX*StrToFloat(IncEdt.Text));

//             YVal := (power(YVal, StrToFloat(ExpEdt.Text)))+StrToFloat(aEdt.Text)+(CurX*StrToFloat(IncEdt.Text));
  //           YVal := Yval-Trunc(YVal);
           except
           end;

           DrawY     := trunc(abs(YVal*PaintBox.Height));
           Sample[A] := DrawY;
           inc(A);

           if (A > High(Sample)) then
           Begin
                DoFFT(Sample, High(Sample));
                B := 1;
                while B <= High(Spectra) div 2 do
                begin
                     Spectra[B] := Sqrt(Sample[B*2-1]*Sample[B*2-1] + Sample[B*2]*Sample[B*2]);
                     Inc(B);
                end;


                Clear;
                    For B := 0 to High(Sample) div 2 do
                    Begin
                         DrawX := B * 2;
                       PaintBox.Canvas.Lock;
                       PaintBox.Canvas.Pen.Color := round(Spectra[B] / 10)+150;
                       PaintBox.Canvas.pen.Width := 1;
                       PaintBox.canvas.MoveTo(DrawX,PaintBox.Height);
                       PaintBox.canvas.LineTo(DrawX, Round(Spectra[B] / 2) );
                       PaintBox.Canvas.UnLock;
                    end;
                    A := 0;
                    Sleep(ChaosForm.SpeedEdt.Value);

           end;

           inc(CurX);
end;

Function ChaosSpectrum(ThreadData : Pointer) : Dword;
Var A          : Dword;
Begin
     Result := 0;
     ChaosForm.YVal  := ChaosForm.InitialValue;
     A     := 0;
     Repeat
           ChaosForm.DrawSpectrum(A);
           //Sleep(ChaosForm.SpeedEdt.Value);
     until (ChaosForm.RenderBtn.Tag = 0);

     EndThread(0);
end;

procedure TChaosForm.RenderBtnClick(Sender: TObject);
var Rect     : TRect;
    Threadid : Dword;
begin
     Input := 0;
     if ((Sender as TButton).Tag = 0) then
     Begin
         Rect.Left   := 0;
         Rect.Top    := 0;
         Rect.Right  := PaintBox.Width;
         Rect.Bottom := PaintBox.Height;
         PaintBox.Canvas.Brush.Color := $000000;
         PaintBox.Canvas.FillRect(Rect);

         Try
            InitialValue := StrToFloat(InitValEdt.Text);
         except
            ShowMessage('- Invalid Initial Value : '+InitValEdt.Text);
            Exit;
         end;

         // -- Iterate View
             (Sender as TButton).Caption := '[- Stop -]';
             (Sender as TButton).Tag     := 1;

         Case ViewGroup.ItemIndex Of
              0:
                 Begin
                      BeginThread(nil,0,@DrawThread,nil,0,ThreadId);
                 end;
              1: Begin
                      ChaosDraw2D;
                 end;
              2: Begin
                      ChaosDraw3D;
                 end;
              3: Begin
                      ChaosDraw4D;
                 end;
              4: Begin
                      BeginThread(nil,0,@ChaosSpectrum,nil,0,ThreadId);
                 end;
         end;
     end
        else
     Begin
         (Sender as TButton).Caption := '[- Render -]';
         (Sender as TButton).Tag     := 0;
     end;
end;

procedure TChaosForm.Clear;
var Rect : TRect;
begin
         Rect.Left   := 0;
         Rect.Top    := 0;
         Rect.Right  := PaintBox.Width;
         Rect.Bottom := PaintBox.Height;
         PaintBox.Canvas.Lock;
         PaintBox.Canvas.Brush.Color := $000000;
         PaintBox.Canvas.FillRect(Rect);
         PaintBox.Canvas.UnLock;
end;

procedure TChaosForm.ClearBtnClick(Sender: TObject);
var Rect : TRect;
begin
         Rect.Left   := 0;
         Rect.Top    := 0;
         Rect.Right  := PaintBox.Width;
         Rect.Bottom := PaintBox.Height;
         PaintBox.Canvas.Lock;
         PaintBox.Canvas.Brush.Color := $000000;
         PaintBox.Canvas.FillRect(Rect);
         PaintBox.Canvas.UnLock;
end;

procedure TChaosForm.InitValEdtChange(Sender: TObject);
begin
     RenderBtnClick(RenderBtn);
     RenderBtnClick(RenderBtn);
end;

procedure TChaosForm.FormCreate(Sender: TObject);
const
     MCW_EM = DWord($133f);
begin
     Set8087CW(MCW_EM);
end;

procedure TChaosForm.InBtn1Click(Sender: TObject);
begin
     Input := 1000;
     ClearBtnClick(Sender);
end;

procedure TChaosForm.InBtn2Click(Sender: TObject);
begin
     Input := 2;
     ClearBtnClick(Sender);
end;

procedure TChaosForm.inbtn3Click(Sender: TObject);
begin
     Input := 100;
     ClearBtnClick(Sender);
end;

procedure TChaosForm.inbtn4Click(Sender: TObject);
begin
     Input := 88;
     ClearBtnClick(Sender);
end;

procedure TChaosForm.inbtn5Click(Sender: TObject);
begin
     Input := Random(9000);
     ClearBtnClick(Sender);
end;

end.
